

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (inaki@blueleaf.cc)

/No description available in the introspection data./
-}

#define ENABLE_OVERLOADING (MIN_VERSION_haskell_gi_overloading(1,0,0) \
       && !defined(__HADDOCK_VERSION__))

module GI.GtkSource.Objects.CompletionContext
    ( 

-- * Exported types
    CompletionContext(..)                   ,
    IsCompletionContext                     ,
    toCompletionContext                     ,
    noCompletionContext                     ,


 -- * Methods
-- ** addProposals #method:addProposals#

#if ENABLE_OVERLOADING
    CompletionContextAddProposalsMethodInfo ,
#endif
    completionContextAddProposals           ,


-- ** getActivation #method:getActivation#

#if ENABLE_OVERLOADING
    CompletionContextGetActivationMethodInfo,
#endif
    completionContextGetActivation          ,


-- ** getIter #method:getIter#

#if ENABLE_OVERLOADING
    CompletionContextGetIterMethodInfo      ,
#endif
    completionContextGetIter                ,




 -- * Properties
-- ** activation #attr:activation#
{- | The completion activation
-}
#if ENABLE_OVERLOADING
    CompletionContextActivationPropertyInfo ,
#endif
#if ENABLE_OVERLOADING
    completionContextActivation             ,
#endif
    constructCompletionContextActivation    ,
    getCompletionContextActivation          ,
    setCompletionContextActivation          ,


-- ** completion #attr:completion#
{- | The 'GI.GtkSource.Objects.Completion.Completion' associated with the context.
-}
#if ENABLE_OVERLOADING
    CompletionContextCompletionPropertyInfo ,
#endif
#if ENABLE_OVERLOADING
    completionContextCompletion             ,
#endif
    constructCompletionContextCompletion    ,
    getCompletionContextCompletion          ,


-- ** iter #attr:iter#
{- | The 'GI.Gtk.Structs.TextIter.TextIter' at which the completion is invoked.
-}
#if ENABLE_OVERLOADING
    CompletionContextIterPropertyInfo       ,
#endif
    clearCompletionContextIter              ,
#if ENABLE_OVERLOADING
    completionContextIter                   ,
#endif
    constructCompletionContextIter          ,
    getCompletionContextIter                ,
    setCompletionContextIter                ,




 -- * Signals
-- ** cancelled #signal:cancelled#

    C_CompletionContextCancelledCallback    ,
    CompletionContextCancelledCallback      ,
#if ENABLE_OVERLOADING
    CompletionContextCancelledSignalInfo    ,
#endif
    afterCompletionContextCancelled         ,
    genClosure_CompletionContextCancelled   ,
    mk_CompletionContextCancelledCallback   ,
    noCompletionContextCancelledCallback    ,
    onCompletionContextCancelled            ,
    wrap_CompletionContextCancelledCallback ,




    ) where

import Data.GI.Base.ShortPrelude
import qualified Data.GI.Base.ShortPrelude as SP
import qualified Data.GI.Base.Overloading as O
import qualified Prelude as P

import qualified Data.GI.Base.Attributes as GI.Attributes
import qualified Data.GI.Base.ManagedPtr as B.ManagedPtr
import qualified Data.GI.Base.GClosure as B.GClosure
import qualified Data.GI.Base.GError as B.GError
import qualified Data.GI.Base.GVariant as B.GVariant
import qualified Data.GI.Base.GValue as B.GValue
import qualified Data.GI.Base.GParamSpec as B.GParamSpec
import qualified Data.GI.Base.CallStack as B.CallStack
import qualified Data.GI.Base.Properties as B.Properties
import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map
import qualified Foreign.Ptr as FP
import qualified GHC.OverloadedLabels as OL

import qualified GI.GObject.Objects.Object as GObject.Object
import qualified GI.Gtk.Structs.TextIter as Gtk.TextIter
import {-# SOURCE #-} qualified GI.GtkSource.Flags as GtkSource.Flags
import {-# SOURCE #-} qualified GI.GtkSource.Interfaces.CompletionProposal as GtkSource.CompletionProposal
import {-# SOURCE #-} qualified GI.GtkSource.Interfaces.CompletionProvider as GtkSource.CompletionProvider
import {-# SOURCE #-} qualified GI.GtkSource.Objects.Completion as GtkSource.Completion

-- | Memory-managed wrapper type.
newtype CompletionContext = CompletionContext (ManagedPtr CompletionContext)
foreign import ccall "gtk_source_completion_context_get_type"
    c_gtk_source_completion_context_get_type :: IO GType

instance GObject CompletionContext where
    gobjectType = c_gtk_source_completion_context_get_type
    

-- | Type class for types which can be safely cast to `CompletionContext`, for instance with `toCompletionContext`.
class (GObject o, O.IsDescendantOf CompletionContext o) => IsCompletionContext o
instance (GObject o, O.IsDescendantOf CompletionContext o) => IsCompletionContext o

instance O.HasParentTypes CompletionContext
type instance O.ParentTypes CompletionContext = '[GObject.Object.Object]

-- | Cast to `CompletionContext`, for types for which this is known to be safe. For general casts, use `Data.GI.Base.ManagedPtr.castTo`.
toCompletionContext :: (MonadIO m, IsCompletionContext o) => o -> m CompletionContext
toCompletionContext = liftIO . unsafeCastTo CompletionContext

-- | A convenience alias for `Nothing` :: `Maybe` `CompletionContext`.
noCompletionContext :: Maybe CompletionContext
noCompletionContext = Nothing

#if ENABLE_OVERLOADING
type family ResolveCompletionContextMethod (t :: Symbol) (o :: *) :: * where
    ResolveCompletionContextMethod "addProposals" o = CompletionContextAddProposalsMethodInfo
    ResolveCompletionContextMethod "bindProperty" o = GObject.Object.ObjectBindPropertyMethodInfo
    ResolveCompletionContextMethod "bindPropertyFull" o = GObject.Object.ObjectBindPropertyFullMethodInfo
    ResolveCompletionContextMethod "forceFloating" o = GObject.Object.ObjectForceFloatingMethodInfo
    ResolveCompletionContextMethod "freezeNotify" o = GObject.Object.ObjectFreezeNotifyMethodInfo
    ResolveCompletionContextMethod "getv" o = GObject.Object.ObjectGetvMethodInfo
    ResolveCompletionContextMethod "isFloating" o = GObject.Object.ObjectIsFloatingMethodInfo
    ResolveCompletionContextMethod "notify" o = GObject.Object.ObjectNotifyMethodInfo
    ResolveCompletionContextMethod "notifyByPspec" o = GObject.Object.ObjectNotifyByPspecMethodInfo
    ResolveCompletionContextMethod "ref" o = GObject.Object.ObjectRefMethodInfo
    ResolveCompletionContextMethod "refSink" o = GObject.Object.ObjectRefSinkMethodInfo
    ResolveCompletionContextMethod "runDispose" o = GObject.Object.ObjectRunDisposeMethodInfo
    ResolveCompletionContextMethod "stealData" o = GObject.Object.ObjectStealDataMethodInfo
    ResolveCompletionContextMethod "stealQdata" o = GObject.Object.ObjectStealQdataMethodInfo
    ResolveCompletionContextMethod "thawNotify" o = GObject.Object.ObjectThawNotifyMethodInfo
    ResolveCompletionContextMethod "unref" o = GObject.Object.ObjectUnrefMethodInfo
    ResolveCompletionContextMethod "watchClosure" o = GObject.Object.ObjectWatchClosureMethodInfo
    ResolveCompletionContextMethod "getActivation" o = CompletionContextGetActivationMethodInfo
    ResolveCompletionContextMethod "getData" o = GObject.Object.ObjectGetDataMethodInfo
    ResolveCompletionContextMethod "getIter" o = CompletionContextGetIterMethodInfo
    ResolveCompletionContextMethod "getProperty" o = GObject.Object.ObjectGetPropertyMethodInfo
    ResolveCompletionContextMethod "getQdata" o = GObject.Object.ObjectGetQdataMethodInfo
    ResolveCompletionContextMethod "setData" o = GObject.Object.ObjectSetDataMethodInfo
    ResolveCompletionContextMethod "setProperty" o = GObject.Object.ObjectSetPropertyMethodInfo
    ResolveCompletionContextMethod l o = O.MethodResolutionFailed l o

instance (info ~ ResolveCompletionContextMethod t CompletionContext, O.MethodInfo info CompletionContext p) => OL.IsLabel t (CompletionContext -> p) where
#if MIN_VERSION_base(4,10,0)
    fromLabel = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#else
    fromLabel _ = O.overloadedMethod (O.MethodProxy :: O.MethodProxy info)
#endif

#endif

-- signal CompletionContext::cancelled
{- |
Emitted when the current population of proposals has been cancelled.
Providers adding proposals asynchronously should connect to this signal
to know when to cancel running proposal queries.
-}
type CompletionContextCancelledCallback =
    IO ()

-- | A convenience synonym for @`Nothing` :: `Maybe` `CompletionContextCancelledCallback`@.
noCompletionContextCancelledCallback :: Maybe CompletionContextCancelledCallback
noCompletionContextCancelledCallback = Nothing

-- | Type for the callback on the (unwrapped) C side.
type C_CompletionContextCancelledCallback =
    Ptr () ->                               -- object
    Ptr () ->                               -- user_data
    IO ()

-- | Generate a function pointer callable from C code, from a `C_CompletionContextCancelledCallback`.
foreign import ccall "wrapper"
    mk_CompletionContextCancelledCallback :: C_CompletionContextCancelledCallback -> IO (FunPtr C_CompletionContextCancelledCallback)

-- | Wrap the callback into a `GClosure`.
genClosure_CompletionContextCancelled :: MonadIO m => CompletionContextCancelledCallback -> m (GClosure C_CompletionContextCancelledCallback)
genClosure_CompletionContextCancelled cb = liftIO $ do
    let cb' = wrap_CompletionContextCancelledCallback cb
    mk_CompletionContextCancelledCallback cb' >>= B.GClosure.newGClosure


-- | Wrap a `CompletionContextCancelledCallback` into a `C_CompletionContextCancelledCallback`.
wrap_CompletionContextCancelledCallback ::
    CompletionContextCancelledCallback ->
    C_CompletionContextCancelledCallback
wrap_CompletionContextCancelledCallback _cb _ _ = do
    _cb 


{- |
Connect a signal handler for the “@cancelled@” signal, to be run before the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.on' completionContext #cancelled callback
@
-}
onCompletionContextCancelled :: (IsCompletionContext a, MonadIO m) => a -> CompletionContextCancelledCallback -> m SignalHandlerId
onCompletionContextCancelled obj cb = liftIO $ do
    let cb' = wrap_CompletionContextCancelledCallback cb
    cb'' <- mk_CompletionContextCancelledCallback cb'
    connectSignalFunPtr obj "cancelled" cb'' SignalConnectBefore

{- |
Connect a signal handler for the “@cancelled@” signal, to be run after the default handler.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Signals.after' completionContext #cancelled callback
@
-}
afterCompletionContextCancelled :: (IsCompletionContext a, MonadIO m) => a -> CompletionContextCancelledCallback -> m SignalHandlerId
afterCompletionContextCancelled obj cb = liftIO $ do
    let cb' = wrap_CompletionContextCancelledCallback cb
    cb'' <- mk_CompletionContextCancelledCallback cb'
    connectSignalFunPtr obj "cancelled" cb'' SignalConnectAfter


-- VVV Prop "activation"
   -- Type: TInterface (Name {namespace = "GtkSource", name = "CompletionActivation"})
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstruct]
   -- Nullable: (Just False,Nothing)

{- |
Get the value of the “@activation@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' completionContext #activation
@
-}
getCompletionContextActivation :: (MonadIO m, IsCompletionContext o) => o -> m [GtkSource.Flags.CompletionActivation]
getCompletionContextActivation obj = liftIO $ B.Properties.getObjectPropertyFlags obj "activation"

{- |
Set the value of the “@activation@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' completionContext [ #activation 'Data.GI.Base.Attributes.:=' value ]
@
-}
setCompletionContextActivation :: (MonadIO m, IsCompletionContext o) => o -> [GtkSource.Flags.CompletionActivation] -> m ()
setCompletionContextActivation obj val = liftIO $ B.Properties.setObjectPropertyFlags obj "activation" val

{- |
Construct a `GValueConstruct` with valid value for the “@activation@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructCompletionContextActivation :: (IsCompletionContext o) => [GtkSource.Flags.CompletionActivation] -> IO (GValueConstruct o)
constructCompletionContextActivation val = B.Properties.constructObjectPropertyFlags "activation" val

#if ENABLE_OVERLOADING
data CompletionContextActivationPropertyInfo
instance AttrInfo CompletionContextActivationPropertyInfo where
    type AttrAllowedOps CompletionContextActivationPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet]
    type AttrSetTypeConstraint CompletionContextActivationPropertyInfo = (~) [GtkSource.Flags.CompletionActivation]
    type AttrBaseTypeConstraint CompletionContextActivationPropertyInfo = IsCompletionContext
    type AttrGetType CompletionContextActivationPropertyInfo = [GtkSource.Flags.CompletionActivation]
    type AttrLabel CompletionContextActivationPropertyInfo = "activation"
    type AttrOrigin CompletionContextActivationPropertyInfo = CompletionContext
    attrGet _ = getCompletionContextActivation
    attrSet _ = setCompletionContextActivation
    attrConstruct _ = constructCompletionContextActivation
    attrClear _ = undefined
#endif

-- VVV Prop "completion"
   -- Type: TInterface (Name {namespace = "GtkSource", name = "Completion"})
   -- Flags: [PropertyReadable,PropertyWritable,PropertyConstructOnly]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@completion@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' completionContext #completion
@
-}
getCompletionContextCompletion :: (MonadIO m, IsCompletionContext o) => o -> m (Maybe GtkSource.Completion.Completion)
getCompletionContextCompletion obj = liftIO $ B.Properties.getObjectPropertyObject obj "completion" GtkSource.Completion.Completion

{- |
Construct a `GValueConstruct` with valid value for the “@completion@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructCompletionContextCompletion :: (IsCompletionContext o, GtkSource.Completion.IsCompletion a) => a -> IO (GValueConstruct o)
constructCompletionContextCompletion val = B.Properties.constructObjectPropertyObject "completion" (Just val)

#if ENABLE_OVERLOADING
data CompletionContextCompletionPropertyInfo
instance AttrInfo CompletionContextCompletionPropertyInfo where
    type AttrAllowedOps CompletionContextCompletionPropertyInfo = '[ 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint CompletionContextCompletionPropertyInfo = GtkSource.Completion.IsCompletion
    type AttrBaseTypeConstraint CompletionContextCompletionPropertyInfo = IsCompletionContext
    type AttrGetType CompletionContextCompletionPropertyInfo = (Maybe GtkSource.Completion.Completion)
    type AttrLabel CompletionContextCompletionPropertyInfo = "completion"
    type AttrOrigin CompletionContextCompletionPropertyInfo = CompletionContext
    attrGet _ = getCompletionContextCompletion
    attrSet _ = undefined
    attrConstruct _ = constructCompletionContextCompletion
    attrClear _ = undefined
#endif

-- VVV Prop "iter"
   -- Type: TInterface (Name {namespace = "Gtk", name = "TextIter"})
   -- Flags: [PropertyReadable,PropertyWritable]
   -- Nullable: (Nothing,Nothing)

{- |
Get the value of the “@iter@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.get' completionContext #iter
@
-}
getCompletionContextIter :: (MonadIO m, IsCompletionContext o) => o -> m (Maybe Gtk.TextIter.TextIter)
getCompletionContextIter obj = liftIO $ B.Properties.getObjectPropertyBoxed obj "iter" Gtk.TextIter.TextIter

{- |
Set the value of the “@iter@” property.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.set' completionContext [ #iter 'Data.GI.Base.Attributes.:=' value ]
@
-}
setCompletionContextIter :: (MonadIO m, IsCompletionContext o) => o -> Gtk.TextIter.TextIter -> m ()
setCompletionContextIter obj val = liftIO $ B.Properties.setObjectPropertyBoxed obj "iter" (Just val)

{- |
Construct a `GValueConstruct` with valid value for the “@iter@” property. This is rarely needed directly, but it is used by `Data.GI.Base.Constructible.new`.
-}
constructCompletionContextIter :: (IsCompletionContext o) => Gtk.TextIter.TextIter -> IO (GValueConstruct o)
constructCompletionContextIter val = B.Properties.constructObjectPropertyBoxed "iter" (Just val)

{- |
Set the value of the “@iter@” property to `Nothing`.
When <https://github.com/haskell-gi/haskell-gi/wiki/Overloading overloading> is enabled, this is equivalent to

@
'Data.GI.Base.Attributes.clear' #iter
@
-}
clearCompletionContextIter :: (MonadIO m, IsCompletionContext o) => o -> m ()
clearCompletionContextIter obj = liftIO $ B.Properties.setObjectPropertyBoxed obj "iter" (Nothing :: Maybe Gtk.TextIter.TextIter)

#if ENABLE_OVERLOADING
data CompletionContextIterPropertyInfo
instance AttrInfo CompletionContextIterPropertyInfo where
    type AttrAllowedOps CompletionContextIterPropertyInfo = '[ 'AttrSet, 'AttrConstruct, 'AttrGet, 'AttrClear]
    type AttrSetTypeConstraint CompletionContextIterPropertyInfo = (~) Gtk.TextIter.TextIter
    type AttrBaseTypeConstraint CompletionContextIterPropertyInfo = IsCompletionContext
    type AttrGetType CompletionContextIterPropertyInfo = (Maybe Gtk.TextIter.TextIter)
    type AttrLabel CompletionContextIterPropertyInfo = "iter"
    type AttrOrigin CompletionContextIterPropertyInfo = CompletionContext
    attrGet _ = getCompletionContextIter
    attrSet _ = setCompletionContextIter
    attrConstruct _ = constructCompletionContextIter
    attrClear _ = clearCompletionContextIter
#endif

#if ENABLE_OVERLOADING
instance O.HasAttributeList CompletionContext
type instance O.AttributeList CompletionContext = CompletionContextAttributeList
type CompletionContextAttributeList = ('[ '("activation", CompletionContextActivationPropertyInfo), '("completion", CompletionContextCompletionPropertyInfo), '("iter", CompletionContextIterPropertyInfo)] :: [(Symbol, *)])
#endif

#if ENABLE_OVERLOADING
completionContextActivation :: AttrLabelProxy "activation"
completionContextActivation = AttrLabelProxy

completionContextCompletion :: AttrLabelProxy "completion"
completionContextCompletion = AttrLabelProxy

completionContextIter :: AttrLabelProxy "iter"
completionContextIter = AttrLabelProxy

#endif

#if ENABLE_OVERLOADING
data CompletionContextCancelledSignalInfo
instance SignalInfo CompletionContextCancelledSignalInfo where
    type HaskellCallbackType CompletionContextCancelledSignalInfo = CompletionContextCancelledCallback
    connectSignal _ obj cb connectMode = do
        let cb' = wrap_CompletionContextCancelledCallback cb
        cb'' <- mk_CompletionContextCancelledCallback cb'
        connectSignalFunPtr obj "cancelled" cb'' connectMode

type instance O.SignalList CompletionContext = CompletionContextSignalList
type CompletionContextSignalList = ('[ '("cancelled", CompletionContextCancelledSignalInfo), '("notify", GObject.Object.ObjectNotifySignalInfo)] :: [(Symbol, *)])

#endif

-- method CompletionContext::add_proposals
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "context", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionContext"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionContext.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "provider", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionProvider"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionProvider.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "proposals", argType = TGList (TInterface (Name {namespace = "GtkSource", name = "CompletionProposal"})), direction = DirectionIn, mayBeNull = True, argDoc = Documentation {rawDocText = Just "The list of proposals to add.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "finished", argType = TBasicType TBoolean, direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "Whether the provider is finished adding proposals.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Nothing
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_context_add_proposals" gtk_source_completion_context_add_proposals :: 
    Ptr CompletionContext ->                -- context : TInterface (Name {namespace = "GtkSource", name = "CompletionContext"})
    Ptr GtkSource.CompletionProvider.CompletionProvider -> -- provider : TInterface (Name {namespace = "GtkSource", name = "CompletionProvider"})
    Ptr (GList (Ptr GtkSource.CompletionProposal.CompletionProposal)) -> -- proposals : TGList (TInterface (Name {namespace = "GtkSource", name = "CompletionProposal"}))
    CInt ->                                 -- finished : TBasicType TBoolean
    IO ()

{- |
Providers can use this function to add proposals to the completion. They
can do so asynchronously by means of the /@finished@/ argument. Providers must
ensure that they always call this function with /@finished@/ set to 'True'
once each population (even if no proposals need to be added).
Population occurs when the 'GI.GtkSource.Interfaces.CompletionProvider.completionProviderPopulate'
function is called.
-}
completionContextAddProposals ::
    (B.CallStack.HasCallStack, MonadIO m, IsCompletionContext a, GtkSource.CompletionProvider.IsCompletionProvider b, GtkSource.CompletionProposal.IsCompletionProposal c) =>
    a
    {- ^ /@context@/: a 'GI.GtkSource.Objects.CompletionContext.CompletionContext'. -}
    -> b
    {- ^ /@provider@/: a 'GI.GtkSource.Interfaces.CompletionProvider.CompletionProvider'. -}
    -> [c]
    {- ^ /@proposals@/: The list of proposals to add. -}
    -> Bool
    {- ^ /@finished@/: Whether the provider is finished adding proposals. -}
    -> m ()
completionContextAddProposals context provider proposals finished = liftIO $ do
    context' <- unsafeManagedPtrCastPtr context
    provider' <- unsafeManagedPtrCastPtr provider
    proposals' <- mapM unsafeManagedPtrCastPtr proposals
    proposals'' <- packGList proposals'
    let finished' = (fromIntegral . fromEnum) finished
    gtk_source_completion_context_add_proposals context' provider' proposals'' finished'
    touchManagedPtr context
    touchManagedPtr provider
    mapM_ touchManagedPtr proposals
    g_list_free proposals''
    return ()

#if ENABLE_OVERLOADING
data CompletionContextAddProposalsMethodInfo
instance (signature ~ (b -> [c] -> Bool -> m ()), MonadIO m, IsCompletionContext a, GtkSource.CompletionProvider.IsCompletionProvider b, GtkSource.CompletionProposal.IsCompletionProposal c) => O.MethodInfo CompletionContextAddProposalsMethodInfo a signature where
    overloadedMethod _ = completionContextAddProposals

#endif

-- method CompletionContext::get_activation
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "context", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionContext"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionContext.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TInterface (Name {namespace = "GtkSource", name = "CompletionActivation"}))
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_context_get_activation" gtk_source_completion_context_get_activation :: 
    Ptr CompletionContext ->                -- context : TInterface (Name {namespace = "GtkSource", name = "CompletionContext"})
    IO CUInt

{- |
Get the context activation.
-}
completionContextGetActivation ::
    (B.CallStack.HasCallStack, MonadIO m, IsCompletionContext a) =>
    a
    {- ^ /@context@/: a 'GI.GtkSource.Objects.CompletionContext.CompletionContext'. -}
    -> m [GtkSource.Flags.CompletionActivation]
    {- ^ __Returns:__ The context activation. -}
completionContextGetActivation context = liftIO $ do
    context' <- unsafeManagedPtrCastPtr context
    result <- gtk_source_completion_context_get_activation context'
    let result' = wordToGFlags result
    touchManagedPtr context
    return result'

#if ENABLE_OVERLOADING
data CompletionContextGetActivationMethodInfo
instance (signature ~ (m [GtkSource.Flags.CompletionActivation]), MonadIO m, IsCompletionContext a) => O.MethodInfo CompletionContextGetActivationMethodInfo a signature where
    overloadedMethod _ = completionContextGetActivation

#endif

-- method CompletionContext::get_iter
-- method type : OrdinaryMethod
-- Args : [Arg {argCName = "context", argType = TInterface (Name {namespace = "GtkSource", name = "CompletionContext"}), direction = DirectionIn, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkSourceCompletionContext.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = False, transfer = TransferNothing},Arg {argCName = "iter", argType = TInterface (Name {namespace = "Gtk", name = "TextIter"}), direction = DirectionOut, mayBeNull = False, argDoc = Documentation {rawDocText = Just "a #GtkTextIter.", sinceVersion = Nothing}, argScope = ScopeTypeInvalid, argClosure = -1, argDestroy = -1, argCallerAllocates = True, transfer = TransferNothing}]
-- Lengths : []
-- returnType : Just (TBasicType TBoolean)
-- throws : False
-- Skip return : False

foreign import ccall "gtk_source_completion_context_get_iter" gtk_source_completion_context_get_iter :: 
    Ptr CompletionContext ->                -- context : TInterface (Name {namespace = "GtkSource", name = "CompletionContext"})
    Ptr Gtk.TextIter.TextIter ->            -- iter : TInterface (Name {namespace = "Gtk", name = "TextIter"})
    IO CInt

{- |
Get the iter at which the completion was invoked. Providers can use this
to determine how and if to match proposals.
-}
completionContextGetIter ::
    (B.CallStack.HasCallStack, MonadIO m, IsCompletionContext a) =>
    a
    {- ^ /@context@/: a 'GI.GtkSource.Objects.CompletionContext.CompletionContext'. -}
    -> m ((Bool, Gtk.TextIter.TextIter))
    {- ^ __Returns:__ 'True' if /@iter@/ is correctly set, 'False' otherwise. -}
completionContextGetIter context = liftIO $ do
    context' <- unsafeManagedPtrCastPtr context
    iter <- callocBoxedBytes 80 :: IO (Ptr Gtk.TextIter.TextIter)
    result <- gtk_source_completion_context_get_iter context' iter
    let result' = (/= 0) result
    iter' <- (wrapBoxed Gtk.TextIter.TextIter) iter
    touchManagedPtr context
    return (result', iter')

#if ENABLE_OVERLOADING
data CompletionContextGetIterMethodInfo
instance (signature ~ (m ((Bool, Gtk.TextIter.TextIter))), MonadIO m, IsCompletionContext a) => O.MethodInfo CompletionContextGetIterMethodInfo a signature where
    overloadedMethod _ = completionContextGetIter

#endif


